
                   
define([
    'dojo/Deferred',
    'sna/applicationComponents/NetworkView/util/UndoStackHelper',
    'sna/applicationComponents/NetworkView/util/NetworkStatefulHelper',
    'sna/applicationComponents/NetworkView/util/NodeLinkFilterHelper',
    'dijit/registry',
    'dojo/_base/lang',
    'dojo/_base/declare',
    'dojox/lang/functional'
], function(Deferred, UndoStackHelper, NetworkStatefulHelper, NodeLinkFilterHelper, registry, lang, declare, functional ) {

    
    var helper = declare(null, {
    });

    helper.perform = function( networkView ) {
        var callbackCounter = 0;
        var entitiesToDelete; 
        var deferred = new Deferred();

        var groupNetworkUndoObject = UndoStackHelper.pop(UndoStackHelper.GROW, networkView);
        if( groupNetworkUndoObject ) {
            entitiesToDelete = groupNetworkUndoObject.uids;

            var nodesToDelete = [];
            var linksToDelete = [];
            for (var i = 0; i < entitiesToDelete.length; i++) {
                var entity = networkView.getEntityFromUID(entitiesToDelete[i]);
                if (entity) {
                    if (entity.type === 'NODE') {
                        nodesToDelete.push(entity);
                    }
                    else if (entity.type === 'LINK') {
                        linksToDelete.push(entity);
                    }
                }
            }

            linksToDelete.forEach(function(link){
                NodeLinkFilterHelper.removeLink(networkView.networkState, link.uid);
            });
            nodesToDelete.forEach(function(node){
                NodeLinkFilterHelper.removeNode(networkView.networkState, node.uid);
            });

            
            networkView.hideNodeSpecificSections();

            
            NetworkStatefulHelper.setNodeDegrees(groupNetworkUndoObject.keyUid, 9999);
            deferred.resolve(networkView.networkState);
        }

        return deferred;
    }; 

    return helper;
});

               