
                   
define([
    "sna/util/marked/marked",
    "dijit/Tooltip",
    "dojox/timing",
    "dojo/query",
    'sna/applicationComponents/NetworkView/util/StatefulArrayUtil',
    'graphics/gtl/core/GTLStateful',
    'commons/geom/Point',
    'dojo/dom-geometry',
    'sna/util/DebugUtil',
    'sna/applicationComponents/NetworkView/util/GroupsHelper',
    'fraudCommons/util/GUIDUtil',
    'graphics/gtl/core/styles/LineAttributes',
    'sna/util/UserPreferenceUtil',
    'graphics/gtl/core/nodeLinkDiagram/ViewportFitPolicyEnum',
    'graphics/gtl/core/VerticalAlignmentEnum',
    'graphics/gtl/core/HorizontalAlignmentEnum',
    'graphics/gtl/core/events/NodeLinkDiagramActionEvent',
    'commons/events/CollectionEvent',
    'sna/applicationComponents/NetworkView/util/NLDThemeUtil',
    'sna/util/IconUtil',
    'dojox/lang/functional',
    'dojo/on',
    'dojo/dom-construct',
    'dojo/dom-style',
    'dojo/_base/declare',
    'graphics/gtl/core/styles/attributesMap/DiscreteAttributesMap',
    'graphics/gtl/core/styles/attributesMap/DiscreteAttributesMapEntry',
    'graphics/gtl/core/styles/FillAttributes',
    'graphics/gtl/core/nodeLinkDiagram/NodeLinkDiagramItemTypeEnum',
    'graphics/gtl/data/ArrayCollectionDataProvider',
    'graphics/gtl/core/ColorModel',
    'graphics/gtl/core/ColorModelTypeEnum',
    'graphics/gtl/layoutRegion/networkDiagram/NetworkDiagram',
    'graphics/gtl/layoutRegion/LayoutRegion',
    'graphics/gtl/Graph',
    'graphics/gtl/data/Role',
    'graphics/gtl/GraphView'
], function( marked, Tooltip, timing, query, StatefulArrayUtil, GTLStateful, Point, domGeometry, DebugUtil, GroupsHelper, GUIDUtil, LineAttributes, UserPreferenceUtil, ViewportFitPolicyEnum, VerticalAlignmentEnum, HorizontalAlignmentEnum,
            NodeLinkDiagramActionEvent, CollectionEvent, NLDThemeUtil, IconUtil, functional,
            on, domConstruct, domStyle, declare, DiscreteAttributesMap, DiscreteAttributesMapEntry, FillAttributes,
            NodeLinkDiagramItemTypeEnum, ArrayCollectionDataProvider, ColorModel, ColorModelTypeEnum,
            NetworkDiagram, LayoutRegion, Graph, Role, GraphView) {
    
	var dx = 0;
    var dy = 0;

	var moveIncrement = 10;
    
    var _theTimer = new timing.Timer(400);
	
    
    var _refresh = function( graph, node ) {
        this._graphView.setSize(node.clientWidth, node.clientHeight);

        
        this._graphView.graphRenderer.setActualSize(node.clientWidth, node.clientHeight);
    };

    var _getTypeStyles = function(vertical, bundlePrefix, callback ) {
        DebugUtil.checkArgs(3, arguments, this);

    	var typeStyles = new DiscreteAttributesMap();
    	IconUtil.updateIconArrayCache(bundlePrefix, vertical, function( networkIconMap ) { 
	    	functional.forIn(networkIconMap, function( iconObject, index ) {
	    		var dame = new DiscreteAttributesMapEntry();
	    		dame.values = iconObject.values;
	    		dame.icon = iconObject.filename;
	    		typeStyles.entries.push(dame);
	    	});

	    	callback(typeStyles);
    	});
    };

    var _mapIsVisible = function(map) {
        var leafletPane = query(".leaflet-map-pane")[0];
        var mapContainer = query(".mapcontainer")[0];
        if(!leafletPane || ('none' === domStyle.get(mapContainer,'display'))){
            return false;
        }
        return true;
    };

    var _getScoreStyles = function() {
        var scoreStyles = new DiscreteAttributesMap();

    	
        var lowStyle = new DiscreteAttributesMapEntry();
        lowStyle.values = ['low'];
        lowStyle.fillAttributes = new FillAttributes();
        lowStyle.fillAttributes.setStyle("fillColor", "0xa0a0c0");
        

        var highStyle = new DiscreteAttributesMapEntry();
        highStyle.values = ['high'];
        highStyle.fillAttributes = new FillAttributes();
        highStyle.fillAttributes.setStyle("fillColor", "0xe11610");

        scoreStyles.entries = [lowStyle, highStyle];

        return scoreStyles;
    };

	
	var helper = declare(null, {
    });

	
	helper.prepare = function( d_container ) {
		var node = domConstruct.toDom('<div class="networkdiagram"></div>'); 
        domConstruct.place(node, d_container);

        return node;
	};

	
	helper.refresh = function( graph, graphContainer ) {
        if(_mapIsVisible(this)) {
            this.controller.networkMapController.calcXY();
            
            
            
            
            var oldHeight = window._graphView.graphRenderer.height;
            if(oldHeight == graphContainer.clientHeight){
                return;
            }
            var shiftAmount = oldHeight - graphContainer.clientHeight;

            var map = this.controller.networkMapController.getMap();
            map.panBy([0,shiftAmount]);
            _refresh(graph, graphContainer);
        }else{
            _refresh(graph, graphContainer);
        }
	};

	helper.dimEntity = function( entityArrayIndex, dim ) {
		this.networkProvider.rowStates.setHiddenAt(dim, entityArrayIndex);
	};

    helper.colorModels = {
        "borderColor": new DiscreteAttributesMap(),
        "linkColor": new DiscreteAttributesMap(),
        "linkStyle": new DiscreteAttributesMap()
    };

    
    helper.namedColorMap = {
        "black": "0x000000",
        "red": "0xCC0000",
        "orange": "0xFF6600",
        "yellow": "0xFFCC00",
        "green": "0x006600",
        "blue": "0x0000CC",
        "purple": "0x660066",
        "gray": "0x999999",
        "white": "0xFFFFFF"
    };

    
	helper.start = function( controller, statefulEntityArray, graphContainer, callbackMap, callback ) {
        var graph = new Graph();

        var ac = statefulEntityArray;
        this.networkProvider = new ArrayCollectionDataProvider();
        this.controller = controller;

        this.networkProvider.setArrayCollection(ac);

        this.addToColorModel('borderColor', '0x000000');
        this.addToColorModel('linkColor', '0x808080');

        
        this.addToColorModel('linkStyle', '0', {
            'lineStyle': 1
        });
        this.addToColorModel('linkStyle', '1', {
            'lineStyle': 1
        });
        this.addToColorModel('linkStyle', '2', {
            'lineStyle': 2
        });
        this.addToColorModel('linkStyle', '3', {
            'lineStyle': 3
        });
        this.addToColorModel('linkStyle', '4', {
            'lineStyle': 4
        });
        this.addToColorModel('linkStyle', '5', {
            'lineStyle': 5
        });






		var riskModel = new ColorModel();
		riskModel.binned = false;
		riskModel._colorModelType = ColorModelTypeEnum.COLOR_LIST;
		riskModel.boundaryValuesNormalized = false;
		riskModel.colorList = [0xced7e0, 0x016cb2, 0x00FF00];

		var that = this;
	    _getTypeStyles(controller.vertical, controller.bundlePrefix, function( typeStyles ) {
            UserPreferenceUtil.retrieve('userpreferencewindow', controller.vertical,  function( showLabelsPreferenceResult ) {
                var scoreStyles = _getScoreStyles();

                
                var networkDiagram = new NetworkDiagram();
                networkDiagram.set("dataProvider", that.networkProvider);
                networkDiagram.set("nodeId", new Role('uid'));
                networkDiagram.set("linkId", new Role('uid'));
                networkDiagram.set("type", new Role('type'));
                networkDiagram.set("nodeX", new Role('positionX'));
                networkDiagram.set("nodeY", new Role('positionY'));
                networkDiagram.set("fromId", new Role('fromNodeId'));
                networkDiagram.set("toId", new Role('toNodeId'));
                networkDiagram.set("nodeIcon", new Role('nodeSymbol', null, null, typeStyles));

                networkDiagram.set("degree", new Role('nodeDegrees'));
                networkDiagram.set("nodeOutlineThicknessValue", new Role('borderSize'));

                networkDiagram.set("nodeOutlineColorGroup", new Role('borderColor', null, null, that.colorModels.borderColor));
                networkDiagram.set("nodeColorValue", new Role('nodeColor'));
                networkDiagram.set("highlightedNodes", new Role('highlight'));

                networkDiagram.set("groupId", new Role('uid'));
                networkDiagram.set("groupParentId", new Role('group'));
                networkDiagram.set("nodeParentId", new Role('group'));
                networkDiagram.set("groupIcon", new Role('nodeSymbol', null, null, typeStyles));
                networkDiagram.set("highlightedGroups", new Role('highlight'));

                
                

                var showNodeLabels = function() {
                    var show = true;

                    if( showLabelsPreferenceResult && showLabelsPreferenceResult.shownodelabelspreferenceselect ) {
                        if( showLabelsPreferenceResult.shownodelabelspreferenceselect.value === 'on' ) {
                            show = false;
                        }
                    }

                    return show;
                };
                
                if( showNodeLabels() === true ) {
                    networkDiagram.set("displayNodeLabels", true);
                    networkDiagram.set("nodeLabel", new Role('nodeLabel'));
                }
                else {
                    networkDiagram.set("displayNodeLabels", false);
                }

                networkDiagram.set("linkWidthMin", 2);
                networkDiagram.set("linkWidthMax", 10);
                
                networkDiagram.set("linkWidthResponse", new Role('linkWidth'));
                networkDiagram.set("linkColorGroup", new Role('linkColor', null, null, that.colorModels.linkColor));
                networkDiagram.set("linkPatternGroup", new Role('linkStyle', null ,null, that.colorModels.linkStyle));
                networkDiagram.set("highlightedLinks", new Role('highlight'));
                networkDiagram.set("linkDirection", new Role('linkDirection'));

                var layoutRegion = new LayoutRegion();
                layoutRegion.set("region", networkDiagram);

                graph.backgroundAttributes.setStyle("transparency", 0);
                graph.set("layout", layoutRegion);
                graph.dataProvider = that.networkProvider;

                var graphView = (new GraphView({container: graphContainer})).placeAt(graphContainer);
                graphView.setGraphStyles(NLDThemeUtil.defaultTheme());
                graphView.set("graph", graph);
                graphView.setImageLibraryPath(IconUtil.displayListDefaultPath);
                this._graphView = graphView;

                var clicks = 0;
                var block = false;

                
                var theTimer = new dojox.timing.Timer(400);

                networkDiagram.addEventListener('mousedown', function (e) {
                	var map = controller.networkMapController.getMap();
                    
                    
                    
                    
                    dx = e.screenX;
                    dy = e.screenY;

                    if(_mapIsVisible(this)) {
                    	map.fire('focus');

                        
                        if (e.shiftKey === true) {
                            var evObj = document.createEvent('MouseEvents');
                                evObj.initMouseEvent( 'mousedown', true, true, window, 1, e.screenX, e.screenY, e.clientX, e.clientY, false, false, false, false, 0, null );
                                divmap.dispatchEvent(evObj);
                                return;
	                    }
                    }
                    Tooltip.hide(query(".networkdiagram")[0]);
                }, that);

                networkDiagram.addEventListener('mousemove', function (e) {
                    var nldRenderer = that.controllerOperations;
                    var mouseOverItem = nldRenderer.get("mouseOverItem");
                    theTimer.stop();

                    if (mouseOverItem !== null) {
                        theTimer.onTick = function(){
                            var dijitTooltip = query(".dijitTooltip")[0];
                            var uid = mouseOverItem.uid;
                            var entity = controller.networkMapController.networkView.getEntityFromUID(uid);
                            var annotation = "";

                            if (mouseOverItem.gtmlTag === "NodeItem") {
                                annotation = entity.nodeToolTip;
                            } else if (mouseOverItem.gtmlTag === "LinkItem") {
                                annotation = entity.linkLabel;
                            } else {
                                this.stop();
                                return;
                            }

                            marked.setOptions({
                                renderer: new marked.Renderer(),
                                gfm: true, 
                                tables: true, 
                                breaks: true, 
                                pedantic: false,
                                sanitize: true, 
                                smartLists: true,
                                smartypants: false
                            });
                            var escapedHTML = marked(annotation);

                            
                            escapedHTML = escapedHTML.replace(/(^<p[^>]*>|<\/p>\n)/g, "");

                            if (annotation == null || annotation.length < 1 || escapedHTML == null || escapedHTML.length < 1) {
                                this.stop();
                                return;
                            }

                            
                            Tooltip.show(escapedHTML, query(".networkdiagram")[0], ["above-centered"]);

                            dijitTooltip = query(".dijitTooltip")[0];

                            var width = dijitTooltip.scrollWidth;
                            var height = dijitTooltip.scrollHeight;

                            dijitTooltip.style.left = (e.clientX - (width/2)) + "px";
                            dijitTooltip.style.top = (e.clientY - height) + "px";
                            this.stop();
                        }
                        theTimer.start();
                    } else {
                        Tooltip.hide(query(".networkdiagram")[0]);
                    }
                }, that);

                networkDiagram.addEventListener('mouseup', function (e) {
                    clicks++;
                    setTimeout(function() {
                        if( clicks === 1 ) {
                            var selectedUids = that.getSelectedUids();

                            
                            dx = e.screenX - dx;
                            dy = e.screenY - dy;
                            if ((selectedUids.length > 0)&& ((dx != 0) || (dy != 0))){
                                
                                controller.networkMapController.networkView.markAsUnsavedChanges();
                            }

                            if( selectedUids.length === 1 ) {
                                callbackMap.entitySingleClick(selectedUids[0]);
                            }
                            else
                            {
                                helper.handleSelectedOddities(callbackMap, selectedUids);
                            }
                        }
                        else {
                            if( block === false ) {
                                block = true;
                                var selectedUids = that.getSelectedUids();
                                if( selectedUids.length === 1 ) {
                                    callbackMap.entityDoubleClick(selectedUids[0]);
                                }
                                else
                                {
                                    helper.handleSelectedOddities(callbackMap, selectedUids);
                                }
                            }
                            else {
                                block = false;
                            }
                        }
                        clicks = 0;

                        
                        if(_mapIsVisible(this)) {
                            var map = controller.networkMapController.getMap();
                            map.fire('focus');
                        }
                    }, 300);

                    
                    var getSelectedEntity = function() {
                        var value;

                        var selectedUids = that.getSelectedUids();
                        if( selectedUids && selectedUids.length === 1 ) {
                            value = selectedUids[0];
                        }
                        return value;
                    };
                }, that);

                networkDiagram.addEventListener("mousewheel", function( e ) {
                    if(_mapIsVisible(this)) {
                        var map = controller.networkMapController.getMap();

                        
                        if (e.wheelDelta > 0) {
                        	var theWheelDelta = -3; 

                            if (map._zoom >= 18) {
                                e.stopPropagation();
                                return;
                            }

                        } else {
							var theWheelDelta = 3; 

                            if (map._zoom <= 0) {
                                e.stopPropagation();
                                return;
                            }
						}

                        var evObj = document.createEvent('MouseEvents');
                        evObj.initMouseEvent('mousewheel', true, true, window, theWheelDelta, e.screenX, e.screenY, e.clientX, e.clientY, false, false, false, false, 0, null );
                        divmap.dispatchEvent(evObj);
                    }
                }, that);

                networkDiagram.addEventListener(NodeLinkDiagramActionEvent.NODE_EXPAND, function( e ) {
                    
                    if( e.items && e.items.length > 0 ) {
                        var nodeItem = e.items[0];

                        var isGroup = (nodeItem.getType() === 'GROUP');
                        if( isGroup === false ) {
                            var map = controller.networkMapController.getMap();
                            var divmap = _mapIsVisible(map);

                            if (divmap) {
                                
                                map.fire('focus');
                                console.log("Don't expand network while in map view");
                            }
                            else {
                                var nodeType;
                                if( nodeItem ) {
                                    var acItem = ac.getItemAt(nodeItem.obsIndex);
                                    
                                    
                                    
                                    acItem.set('nodeDegrees', 0);
                                    nodeType = acItem.get('nodeType'); 
                                }

                                controller.startGrowNetworkActions(nodeItem.get('uid'), nodeType);
                            }
                        }
                        else {
                            controller.removeGroup(nodeItem.get('uid'));
                        }
                    }
                }, that);

                networkDiagram.addEventListener("controllerOperationsAvailable", function (e) {
                    that.controllerOperations = e.controllerOperations;
                }, that);

                
                on(window, 'resize', function() {
                    _refresh(graph, graphContainer);
                });
                if( callback ) {
                    callback(graph);
                }
            });
	    });
        this.graph = graph;
	}; 

    helper.getSelectedUids = function () {
        var uids = [];
        var rowStates = this.networkProvider.rowStates;
        if (rowStates.getAnySelected()) {
            var selectedIndices = rowStates.selectedIndices;
            for (var i = rowStates.nSelectedIndices - 1; i >= 0; i--) {
                var obs = this.networkProvider._arrayCollection.getItemAt(selectedIndices[i]);
                uids.push(obs.uid);
            }
        }
        return uids;
    };

    helper.handleSelectedOddities = function(callbackMap, selectedUids) {
        if( selectedUids.length > 1 ) { 
            callbackMap.multipleEntitiesSelected(selectedUids);
        }
        else { 
            callbackMap.noEntitiesSelected();
        }
    };

    helper.setDraggable = function (flag) {
        if(this.controllerOperations) {
            this.controllerOperations.editable = flag;
        }
    };

    helper.getCenterOfGraph = function() {
        var dims = (domGeometry.position(this.controllerOperations.graphView.container));
        return new Point(dims.x + (dims.w/2), dims.y + (dims.h/2));
    };

    helper.zoomIn = function() {
        this.controllerOperations.zoomIn(helper.getCenterOfGraph());
    };

    helper.zoomOut = function() {
        this.controllerOperations.zoomOut(helper.getCenterOfGraph());
    };

    helper.getZoom = function() {
        return this.controllerOperations.getZoomScale();
    };

    helper.setZoom = function(value) {
        this.controllerOperations.setZoomScale(value);
    };

    
    helper.shiftNetworkHorizontal = function(shiftAmount) {
        if(_mapIsVisible(this)) {
            var map = this.controller.networkMapController.getMap();
            map.panBy([-shiftAmount,0]);
        }else{
            var originalPosition = this.controllerOperations.getHorizontalScrollPosition();
            
            
            this.controllerOperations.setHorizontalScrollPosition(originalPosition - shiftAmount);
        }
    };

	helper.panLeft = function() {
		var origLeft = this.controllerOperations.getHorizontalScrollPosition();
		this.controllerOperations.setHorizontalScrollPosition(origLeft + moveIncrement);
	};

	helper.panRight = function() {
		var origRight = this.controllerOperations.getHorizontalScrollPosition();
		this.controllerOperations.setHorizontalScrollPosition(origRight - moveIncrement);
	};

    helper.setTransparency = function(value) {
        this.graph.backgroundAttributes.setStyle("transparency", value);
    };

    helper.getTransparency = function() {
        this.graph.backgroundAttributes.getStyle("transparency");
    };

	helper.panUp = function() {
		var origUp = this.controllerOperations.getVerticalScrollPosition();
		this.controllerOperations.setVerticalScrollPosition(origUp - moveIncrement);
	};

	helper.panDown = function() {
		var origDown = this.controllerOperations.getVerticalScrollPosition();
		this.controllerOperations.setVerticalScrollPosition(origDown + moveIncrement);
	};

	helper.center = function() {
        this.controllerOperations.invalidateSize();

        this.controllerOperations.setViewportAlignment(HorizontalAlignmentEnum.CENTER, VerticalAlignmentEnum.CENTER, ViewportFitPolicyEnum.BOTH);
	};
	
	helper.localToData = function( point ) {
		return this.controllerOperations.localToData(point);
	};
	
    helper.addToColorModel = function(model, colorString, attributes) {
        this.colorModels[model].existingColors = this.colorModels[model].existingColors || {};
        if(this.colorModels[model].existingColors[colorString]) {
            return; 
        }
        else {
            this.colorModels[model].existingColors[colorString] = true;
        }

        var style = new DiscreteAttributesMapEntry();
        style.values = [colorString];
        style.lineAttributes = new LineAttributes();

        if(attributes) {
            functional.forIn(attributes, function(value, key) {
                style.lineAttributes.setStyle(key, value);
            });
        }
        else {
            style.lineAttributes.setStyle("lineColor", colorString);
        }

        this.colorModels[model].entries.push(style);
    },

	helper.getCurrentlySelectedIndices = function() {
		var selectedIndices = [];
		for( var i = 0; i < this.networkProvider.rowStates.selected.length; i++ ) {
			var rowStateSelected = this.networkProvider.rowStates.selected[i];
			
			if( rowStateSelected === true ) {
				selectedIndices.push(i);
			}
		}
		
		return selectedIndices;
	};

    helper.getUnselectedIndices = function() {
        var unselectedIndices = [];
        for( var i = 0; i < this.networkProvider.rowStates.selected.length; i++ ) {
            var rowStateSelected = this.networkProvider.rowStates.selected[i];

            if( rowStateSelected !== true ) {
                unselectedIndices.push(i);
            }
        }

        return unselectedIndices;
    }

    helper.getSelected = function () {
        var selected = [];
        var rowStates = this.networkProvider.rowStates;
        var ac = this.networkProvider._arrayCollection;
        if (rowStates.getAnySelected()) {
            var selectedIndices = rowStates.selectedIndices;
            for (var i = rowStates.nSelectedIndices - 1; i >= 0; i--) {
                selected.push(ac.getItemAt(selectedIndices[i]));
            }
        }

        return selected;
    };

    
    helper.createNewGroup = function (id, children) {
        
        if (!children || children.length < 2) {
            return;
        }

        var groupUid = id;
        if( !groupUid ) {
            groupUid = GUIDUtil.generate();
        }

        var group = new GTLStateful({
            uid: groupUid,
            type: NodeLinkDiagramItemTypeEnum.GROUP,
            score: "group",
            nodeSymbol: GroupsHelper.GROUPICON,
            children: []
        });
        var i;
        for( i = children.length - 1; i >= 0; i-- ) {
            var node = children[i];
            node.group = group.uid;
            group.children.push(node);
        }

        if( group ) {
            var that = this;
            var existingGroup = StatefulArrayUtil.getStatefulEntity(groupUid, that.networkProvider._arrayCollection);
            if(!existingGroup) {
                this.networkProvider._arrayCollection.addItem(group);
            }
            else {
                existingGroup.set('children', group.children);
            }
            this.networkProvider.rowStates.setSelectedAll(false);
        }

        return group;
    };

    helper.groupSelected = function() {
        helper.createNewGroup(null, helper.getSelected());
    };
    
    return helper;
});

               