
                   define([
    'dijit/_TemplatedMixin',
    'dijit/_WidgetBase',
    'dijit/_WidgetsInTemplateMixin',
    'dijit/registry',
    'dijit/TitlePane',
    'dojo/_base/declare',
    'dojo/_base/lang',
    'dojo/dom-class',
    'dojo/dom-construct',
    'dojo/dom-style',
    'dojo/query',
    'dojo/sniff',
    'dojo/text!./templates/NetworkPrintView.html',
    'sna/util/I18nUtil'
], function( TemplatedMixin, WidgetBase, WidgetsInTemplateMixin, registry, TitlePane, declare, lang, domClass, domConstruct, domStyle, query, has, template, I18nUtil ) {
    return declare([WidgetBase, TemplatedMixin, WidgetsInTemplateMixin], {
        templateString: template,

        constructor: function( args ) {
            this.inherited(arguments);
        },

        buildRendering: function() {
            this.inherited(arguments);
        },

        postMixinProperties: function() {
            this.inherited(arguments);
        },

        startup: function() {
            this.inherited(arguments);
        },

        postCreate: function() {
            this.inherited(arguments);

            this.h1title.innerHTML = I18nUtil.get('networkview_networkwithcontext', this.networkView.networkState.vertical);
        },

        print: function() {
            var that = this;

            var w = window.open();

            var theCanvas = query('canvas', this.networkView.snadiagramcontentpane.domNode);
            var nldCanvas0 = theCanvas[0]; 
            var nldCanvas1 = theCanvas[1]; 
            var nldCanvas2 = theCanvas[2]; 
            var nldCanvas3 = theCanvas[3]; 
            var imageVar = query('div', this.networkView.snadiagramcontentpane.domNode)[0]; 

            
            var timeSlider = this.networkView.timeslidercontainer;
            var timeSliderMin = timeSlider.get('minimum');
            var timeSliderValue = timeSlider.get('value');

            
            var img0 = nldCanvas0.toDataURL("image/png");
            var img1 = nldCanvas1.toDataURL("image/png");
            var img2 = nldCanvas2.toDataURL("image/png");
            var img3 = nldCanvas3.toDataURL("image/png");

            var imgDomFinal0 = domConstruct.toDom('<img src="%0" style="position: absolute; top: 0px; left: 0px; z-index: -1; height:%1px"/>'.tokenize(img0, nldCanvas0.height));
            var imgDomFinal1 = domConstruct.toDom('<img src="%0" style="position: absolute; top: 0px; left: 0px; z-index: -1; height:%1px"/>'.tokenize(img1, nldCanvas1.height));
            var imgDomFinal2 = domConstruct.toDom('<img src="%0" style="position: absolute; top: 0px; left: 0px; z-index: -1; height:%1px"/>'.tokenize(img2, nldCanvas2.height));
            var imgDomFinal3 = domConstruct.toDom('<img src="%0" style="position: absolute; top: 0px; left: 0px; z-index: -1; height:%1px"/>'.tokenize(img3, nldCanvas3.height));

            domConstruct.place(imgDomFinal0, this.imgcontainer.domNode);
            domConstruct.place(imgDomFinal1, this.imgcontainer.domNode);
            domConstruct.place(imgDomFinal2, this.imgcontainer.domNode);
            domConstruct.place(imgDomFinal3, this.imgcontainer.domNode);

            domClass.add(this.imgcontainer.domNode, 'imgContainer');

            var title = I18nUtil.get('networkview_printview');
            w.document.write(
                '<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">' +
                    '<link rel="stylesheet" type="text/css" href="src/dijit/applicationThemes/corporate/corporate.css">' +
                    '<link rel="stylesheet" type="text/css" href="src/leaflet/leaflet.css">' +
                    '<style>' +
                        '.imgContainer {height:' + nldCanvas0.height + 'px} ' +
                    '</style>' +
                    '<script>window.setTimeout(function() {window.print();}, 1000);</script>' +
                    '<title>%0</title></head><body class="corporate">'.tokenize(title));

            
            if(!isNaN(timeSliderMin)) {
                if (timeSliderMin === timeSliderValue || this.networkView.model.controller.marginal.get('checked')) { 
                    this.timeSliderValues.set('content', timeSlider._getDisplayValueFromRawValue(timeSliderValue));
                } else if (isNumber(timeSliderMin) && timeSliderValue > 0 && timeSliderMin != timeSliderValue) { 
                    this.timeSliderValues.set('content', timeSlider._getDisplayValueFromRawValue(timeSliderMin) + ' - ' + timeSlider._getDisplayValueFromRawValue(timeSliderValue));
                }
            }

            var legendWidget = undefined;

            if(this.networkView.model.plugins){
                legendWidget = this.networkView.model.plugins['src/sna/plugins/NetworkLegend/NetworkLegend'];
            }

            if(legendWidget) {
                
                if(!legendWidget._dialog || !legendWidget._dialog.open) {
                    legendWidget._legendButtonClicked(this.networkView, legendWidget.data, this.networkView.networkState.vertical,true);
                }

                
                
            
            
            
            
            
            
            
            
            
            
            
            
            
            

                this.networkLegendPrintView.set('content', '<div class="iconPane">' + legendWidget.iconPane.domNode.innerHTML + '</div><div class="colorPane">'+ legendWidget.colorPane.domNode.innerHTML + '</div>');
            }

            w.document.write(imageVar.outerHTML);
            w.document.write(this.domNode.innerHTML);

            w.document.write('</body></html>');
            w.document.close();
        }
    });
});

               