
                   define([
    'dijit/_TemplatedMixin',
    'dijit/_WidgetBase',
    'dijit/_WidgetsInTemplateMixin',
    'dijit/layout/TabContainer',
    'dojo/_base/declare',
    'dojo/_base/lang',
    'dojo/dom-construct',
    'dojo/text!./templates/TabbedDialogContainer.html',
    'dojox/lang/functional',
    'sna/util/I18nUtil'
], function( TemplatedMixin, WidgetBase, WidgetsInTemplateMixin, TabContainer, declare, lang, domConstruct, template, functional, I18nUtil ) {
	
	var _populate = function( contentArray ) {
		if( contentArray.length === 1 ) {
			var dialog = contentArray[0].domNode;
			domConstruct.place(dialog, this.maincontentarea, 'last');
		}
	    else if( contentArray.length > 1 ) {
			var tc = new TabContainer( {
	    		style: 'width:805px; height:475px'
	    	});
			
			domConstruct.place(tc.domNode, this.maincontentarea, 'last');
			
			functional.forIn(contentArray, function( content, index ) {
				tc.addChild(content);
			});
			
	    	tc.startup();
	    	tc.resize();
		}
	};
	
    return declare([WidgetBase, TemplatedMixin, WidgetsInTemplateMixin], {
    	templateString: template,
    	
    	constructor: function( args ) {
    	    this.inherited(arguments);
    	    
    	    this.title = args.title || '';
    	    this.eventMap = args.eventMap || {};
    	},
    	
        buildRendering: function() {
        	this.inherited(arguments);
        },
        
        postMixinProperties: function() {
        	this.inherited(arguments);
        },
        
        startup: function() {
        	this.inherited(arguments);
        },
        
        postCreate: function() {
        	this.inherited(arguments);
        	
        	this.addnode_okbutton.set('label', I18nUtil.get('global_ok'));
        	this.addnode_cancelbutton.set('label', I18nUtil.get('global_cancel'));
        	this.masterDialog.set('title', this.title);
        },
        
        showDialog: function() {
        	this.masterDialog.show();
        },
        
        populate: function( contentArray ) {
        	this.contentArray = contentArray;
        	
        	lang.hitch(this, _populate, contentArray)();
        },
        
        end: function() {
        	this.masterDialog.destroyRecursive();
        },
        
        _submitForm: function() {
        	var hasInvalidContent = false;
        	functional.forIn(this.contentArray, function( content, index ) {
        		if( content.validate() === false ) {
        			hasInvalidContent = true;
        		}
        	});
        	
        	if( hasInvalidContent === false && this.eventMap.onSubmit ) {
        		var payloadArray = [];
        		functional.forIn(this.contentArray, function( content, index ) {
        			payloadArray.push(content.getPayloadObject());
        		});
        		
        		this.eventMap.onSubmit(payloadArray);
        	}
        },
        
        _cancel: function() {
        	this.masterDialog.destroyRecursive();
        }
    });
});

               