
                   


define([
    'dojo/topic',
    'sna/model/ContextModel',
    'dojo/_base/declare',
    'sna/model/GlobalToolbarModel'
], function (topic, ContextModel, declare, GlobalToolbarModel) {
    var model;

    return declare([], {
        constructor: function (args) {
            this.bizDomainPromptController = args.bizDomainPromptController;
            this.userPreferenceWindowController = args.userPreferenceWindowController;
            this.advancedSearchController = args.advancedSearchController;
            this.printViewController = args.printViewController;
            this.exportListController = args.exportListController;
            this.aboutWindowController = args.aboutWindowController;
            this.viewSwitcherController = args.viewSwitcherController;

            this.model = new GlobalToolbarModel({
                controller: this
            });

            var _this = this;
            ContextModel.watch('currentAnalyticContext', function (name, oldValue, newValue) {
                _this.displayCurrentAnalyticDomain(newValue);
            });
        },

        
        start: function () {
            this.model.handleEvents();
        },

        refreshButtonClicked: function () {
            var currentVertical = ContextModel.get('currentAnalyticContext');
            this.viewSwitcherController.alertDetailsController.customView.appliedView = null;
            this.viewSwitcherController.switchToAlertsListPage(true, currentVertical, this.viewSwitcherController.getAdvancedSearchParameters(), true, undefined);
            this.viewSwitcherController.alertsViewController.customView.clearCustomViewIndicator();
        },

        switchDomainButtonClicked: function (vertical) {
            this.bizDomainPromptController.bizDomainSelect(vertical, true, false);
        },

        preferencesWindowButtonClicked: function () {
            this.userPreferenceWindowController.start();
        },

        advancedSearchButtonClicked: function () {
            var that = this;
            var currentVertical = ContextModel.get('currentAnalyticContext');
            this.advancedSearchController.loadAndStartAdvancedSearch(currentVertical, false);
        },

        updateAnalyticDomainsList: function (domainsStore) {
            this.model.updateAnalyticDomainsList(domainsStore);
        },

        displayCurrentAnalyticDomain: function (vertical) {
            this.model.updateAnalyticDomain(vertical);
        },

        showPrintView: function () {
            this.printViewController.show();
        },

        exportList: function () {
            this.exportListController.exportData();
        },

        aboutWindowButtonClicked: function () {
            this.aboutWindowController.start();
        },

        logoff: function () {
            topic.publish('logoff', '');
        }
    });
});


               